#include <stddef.h>

/* NULLs are "reserved" */

/* Usage Pages */

/* 0x00 - 0x14 */
const char *usage_page_name_0000 [] =
{
	"Undefined",
	"Generic Desktop",			/* important */
	"Simulation Controls",
	"VR Controls",
	"Sport Controls",
	"Game Controls",
	NULL,
	"Keyboard/Keypad",			/* important */
	"LEDs",						/* important */
	"Button",					/* important */
	"Ordinal",
	"Telephony",
	"Consumer",
	"Digitizer",
	NULL,
	"PID Page",
	
	"Unicode",
	NULL, NULL, NULL,
	"Alphanumeric Display",
};

/* 0x80 - 0x91 */
const char *usage_page_name_0080 [] =
{
	"Monitor Page 0x80",
	"Monitor Page 0x81",
	"Monitor Page 0x82",
	"Monitor Page 0x83",
	"Power Page 0x84",
	"Power Page 0x85",
	"Power Page 0x86",
	"Power Page 0x87",
	NULL, NULL, NULL, NULL, 
	"Bar Code Scanner Page",
	"Scale Page",
	NULL, NULL,
	"Camera Control Page",
	"Arcade Page"
};

/* Generic Desktop Page */

/* 0x00 - 0x08 */
const char *generic_desktop_usage_name_0000 [] =
{
	"Undefined",
	"Pointer",			/* important */
	"Mouse",			/* important */
	NULL,
	"Joystick",			/* important */
	"Game Pad",			/* important */
	"Keyboard",			/* important */
	"Keypad",			/* important */
	"Multi-axis Controller",
};

/* 0x30 - 0x46 */
const char *generic_desktop_usage_name_0030 [] =
{
	"X",			/* important */
	"Y",			/* important */
	"Z",
	"Rx",			/* important */
	"Ry",			/* important */
	"Rz",
	"Slider",
	"Dial",
	"Wheel",
	"Hat switch",
	"Counted Buffer",
	"Byte Count",
	"Motion Wakeup",
	"Start",
	"Select",
	"Reserved",
	"Vx",
	"Vy",
	"Vz",
	"Vbrx",
	"Vbry",
	"Vbrz",
	"Vno"
};

/* 0x80 - 0x93 */
const char *generic_desktop_usage_name_0080 [] =
{
	"System Control",
	"System Power Down",
	"System Sleep",
	"System Wake Up",
	"System Context Menu",
	"System Main Menu",
	"System App Menu",
	"System Menu Help",
	"System Menu Exit",
	"System Menu Select",
	"System Menu Right",
	"System Menu Left",
	"System Menu Up",
	"System Menu Down",
	NULL,
	NULL,
	"D-pad Up",
	"D-pad Down",
	"D-pad Right",
	"D-pad Left",
};

/* LED page */

const char *led_usage_name [] =
{
	"Undefined",
	"Num Lock",
	"Caps Lock",
	"Scroll Lock",
	"Compose",
	"Kana",
	"Power",
	"Shift",
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	/* 0x10 - */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	/* 0x20 - */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	/* 0x30 - */
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, 
	/* 0x3a - */
	"Usage Selected Indicator",
	"Usage In Use Indicator",
	"Usage Multi Mode Indicator",
	"Indicator On",
	"Indicator Flash",
	"Indicator Slow Blink",
	/* 0x40 - */
	"Indicator Fast Blink",
	"Indicator Off",
	"Flash On Time",
	"Slow Blink On Time",
	"Slow Blink Off Time",
	"Fast Blink On Time",
	"Fast Blink Off Time",
	"Usage Indicator Color",
	"Indicator Red",
	"Indicator Green",
	"Indicator Amber",
	"Generic Indicator",
	"System Suspend",
	"External Power Connected"
};
